<template>
  <div v-show="view">
    <div v-if="isFailed()" class="bulk-status">
      <v-icon class="close-circle">
        mdi-close-circle
      </v-icon>
      &nbsp; No se han podido cargar los datos del archivo
      <a
        @click.prevent="downloadCorrectItem()"
      >
        <div class="display-button">
          especialistas.csv &nbsp;
          <v-icon class="download">
            mdi-cloud-download
          </v-icon>
        </div>
      </a>
    </div>
    <div v-if="isFinished()" class="bulk-status">
      <v-icon>mdi-check-circle-outline</v-icon>
      &nbsp; {{ numCorrects }} especialistas cargados correctamente
      <a
        target="_blank"
        @click.prevent="downloadCorrectItem()"
      >
        <v-icon class="download">
          mdi-cloud-download
        </v-icon>
      </a>
    </div>
    <v-divider />
    <div v-if="existsFailed()" class="bulk-status">
      <v-icon class="alert">
        mdi-alert
      </v-icon>
      &nbsp; {{ numIncorrects }}} especialistas no cargados por errores
      <a
        target="_blank"
        @click.prevent="downloadIncorrectItem()"
      >
        <v-icon class="download">
          mdi-cloud-download
        </v-icon>
      </a>
    </div>
    <div v-else-if="isFailed()" class="bulk-failed">
      Esto puede deberse a que el archivo esté corrompido.<br>
      Intente cargando un nuevo archivo
    </div>
    <div v-else class="bulk-status">
      <v-icon>mdi-check-circle-outline</v-icon>
      &nbsp; No existen errores al cargar
    </div>
  </div>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import { bulkStates, bulkResultFileTypes } from '~/helpers/enums/bulk';
// import Axios from 'axios';

export default {
  name: 'NoResultsYet',
  props: {
    state: {
      type: String,
      required: true,
    },
    view: {
      type: Boolean,
      required: true,
    },
  },
  data: () => ({
    watchVar: null,
    numCorrects: 0,
    numIncorrects: 0,
  }),
  computed: {
    ...mapState({
      currentBulk: state => state.bulk.currentBulk,
      currentBulkFile: state => state.bulk.currentBulkFile,
      bulkState: state => state.bulk.bulkState,
    }),
  },
  watch: {
    currentBulk() {
      this.numCorrects = this.currentBulk.bulkLoad.successfulRegistered;
      this.numIncorrects = this.currentBulk.bulkLoad.failedRegistered;
      console.log('nums', this.numCorrects, this.numIncorrects);
    },
  },
  //   mounted() {
  //     this.currentBulk;
  //     console.log('watchvar', this.currentBulk);
  //   },
  methods: {
    ...mapActions({
      getCurrentBulkFile: 'bulk/getCurrentBulkFile',
    }),
    existsFailed() {
      return (this.numIncorrects !== 0);
    },
    isFailed() {
      return bulkStates.FAILED.value === this.bulkState;
    },
    isFinished() {
      return bulkStates.FINISHED.value === this.bulkState;
    },
    async downloadCorrectItem() {
      await this.getCurrentBulkFile({ id: this.currentBulk.bulkLoad.id, type: bulkResultFileTypes.ORIGINAL.value });
      this.download();
    },
    async downloadIncorrectItem() {
      await this.getCurrentBulkFile({ id: this.currentBulk.bulkLoad.id, type: bulkResultFileTypes.ERROR.value });
      this.download();
    },
    download() {
      const fileLink = document.createElement('a');
      fileLink.href = this.currentBulkFile;
      document.body.appendChild(fileLink);
      fileLink.click();
    },
  },
};
</script>

<style scoped>
.v-icon.v-icon{
    color: #1ECD96;
    margin-bottom: 0.5rem;
}
.v-icon.v-icon.alert{
    color: #EBCA57;
    margin-bottom: 0.5rem;
}
.v-icon.v-icon.close-circle{
    color: #ED4337;
    margin-bottom: 0.5rem;
}
.bulk-status{
    text-align-last: left;
    margin: 1rem;
}
.bulk-failed{
    text-align-last: center;
    margin: 2rem;
}
.v-icon.v-icon.download{
    color: #535B6C;
    /* display: flex;
    float: right; */
}
.display-button{
    display: flex;
    float: right;
    color: #535B6C;
}
a:hover {
 cursor:pointer;
}
</style>
